Module SQL_財務系統管理
    '---------------------日報表.------------------------------------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_當日簽單()
        ConnOpen()
        SQL1 = "SELECT     銷售控制表.開單日期, 銷售控制表.單號, 客戶資料表.名稱, SUM(銷售明細表.售價 * 銷售明細表.數量) AS 簽單金額, 
                           WWW.收入1 AS 其他應收, QQQ.收入 AS 目前已收, QQQ.收入 AS 未收餘額
                FROM       銷售控制表 FULL OUTER JOIN
                           銷售明細表 ON 銷售控制表.單號 = 銷售明細表.單號 FULL OUTER JOIN
                           客戶資料表 ON 銷售控制表.客戶編號 = 客戶資料表.舊編 FULL OUTER JOIN
                          (SELECT  SUM(CAST(收入 AS decimal(18, 2))) AS 收入, LEFT(明細, 7) AS 單號1  FROM  公帳流水帳
                           WHERE  (CAST(收入 AS decimal(18, 2)) <> 0) AND (明細 NOT LIKE '') AND (PATINDEX('%[^0-9]%', RIGHT(LEFT(明細, 7), 4)) = 0)
                           GROUP BY    LEFT(明細, 7)) AS QQQ ON LEFT(銷售控制表.單號, 7) = QQQ.單號1 FULL OUTER JOIN
                          (SELECT  單號, SUM(收入) AS 收入1  FROM  銷售備註表  WHERE  (收入 <> 0)  GROUP BY  單號) AS WWW ON 銷售控制表.單號 = WWW.單號
                WHERE     (銷售控制表.開單日期 LIKE '" & PA & "')
                GROUP BY   銷售控制表.開單日期, 銷售控制表.單號, 客戶資料表.名稱, QQQ.收入, WWW.收入1
                HAVING    (SUM(銷售明細表.售價 * 銷售明細表.數量) > 0)
                ORDER BY   CHARINDEX(LEFT(銷售控制表.單號, 1), '123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'), 銷售控制表.單號 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_當日送貨()
        ConnOpen()
        SQL1 = "SELECT     倉儲明細表.作業日期, 倉儲明細表.採購單號 AS 單號, 客戶資料表.名稱, SUM(銷售明細表.售價 * 銷售明細表.數量) 
                           AS 簽單金額, WWW.收入1 AS 其他應收, QQQ.收入 AS 目前已收, QQQ.收入 AS 未收餘額
                FROM      (SELECT      SUM(CAST(收入 AS decimal(18, 2))) AS 收入, LEFT(明細, 7) AS 單號1
                           FROM        公帳流水帳
                           WHERE      (CAST(收入 AS decimal(18, 2)) <> 0) AND (明細 NOT LIKE '') AND (PATINDEX('%[^0-9]%', 
                                       RIGHT(LEFT(明細, 7), 4)) = 0)
                           GROUP BY    LEFT(明細, 7)) AS QQQ RIGHT OUTER JOIN
                           銷售控制表 ON QQQ.單號1 = 銷售控制表.單號 LEFT OUTER JOIN
                           銷售明細表 ON 銷售控制表.單號 = 銷售明細表.單號 LEFT OUTER JOIN
                           客戶資料表 ON 銷售控制表.客戶編號 = 客戶資料表.舊編 RIGHT OUTER JOIN
                           倉儲明細表 ON 銷售控制表.單號 = 倉儲明細表.採購單號 LEFT OUTER JOIN
                          (SELECT      單號, SUM(收入) AS 收入1
                           FROM        銷售備註表
                           WHERE      (收入 <> 0)
                           GROUP BY    單號) AS WWW ON 銷售控制表.單號 = WWW.單號
                WHERE     (銷售控制表.交貨日期 LIKE '" & PA & "') AND (倉儲明細表.採購單號 NOT LIKE '') AND (倉儲明細表.入庫 = 0)
                GROUP BY   倉儲明細表.作業日期, 倉儲明細表.採購單號, 客戶資料表.名稱, WWW.收入1, QQQ.收入
                HAVING    (SUM(銷售明細表.售價 * 銷售明細表.數量) > 0)
                ORDER BY   CHARINDEX(LEFT(倉儲明細表.採購單號, 1), '123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'), 單號 DESC"
        '倉儲明細表.作業日期 LIKE '" & PA & "'
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_當日送貨1()
        ConnOpen()
        SQL1 = "SELECT     銷售控制表.交貨日期 AS 作業日期, 銷售控制表.單號, 客戶資料表.名稱, SUM(銷售明細表.售價 * 銷售明細表.數量) 
                           AS 簽單金額, WWW.收入1 AS 其他應收, QQQ.收入 AS 目前已收, QQQ.收入 AS 未收餘額
                FROM       銷售明細表 RIGHT OUTER JOIN
                           銷售控制表 ON 銷售明細表.單號 = 銷售控制表.單號 LEFT OUTER JOIN
                           客戶資料表 ON 銷售控制表.客戶編號 = 客戶資料表.舊編 LEFT OUTER JOIN
                          (SELECT  SUM(CAST(收入 AS decimal(18, 2))) AS 收入, LEFT(明細, 7) AS 單號1
                           FROM    公帳流水帳  WHERE  (CAST(收入 AS decimal(18, 2)) <> 0) AND (明細 NOT LIKE '') AND (PATINDEX('%[^0-9]%', RIGHT(LEFT(明細, 7), 4)) = 0)
                           GROUP BY  LEFT(明細, 7)) AS QQQ ON 銷售控制表.單號 = QQQ.單號1 FULL OUTER JOIN
                          (SELECT  單號, SUM(收入) AS 收入1 FROM  銷售備註表  WHERE  (收入 <> 0)
                           GROUP BY  單號) AS WWW ON 銷售控制表.單號 = WWW.單號
                WHERE     (銷售控制表.交貨日期 LIKE '" & PA & "') AND (銷售控制表.轉高層 = 1)
                GROUP BY   銷售控制表.交貨日期, 銷售控制表.單號, 客戶資料表.名稱, WWW.收入1, QQQ.收入
                ORDER BY   CHARINDEX(LEFT(銷售控制表.單號, 1), '123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'), 單號 DESC"
        '倉儲明細表.作業日期 LIKE '" & PA & "'
        CmdSet_For_DGV()
    End Sub
    '---------------------匯率管理.------------------------------------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_匯率管理_歷史匯率清單()
        ConnOpen()
        SQL1 = "SELECT 年, 月, 買進匯率, 賣出匯率, 中心匯率, 美金匯率 FROM 歷史匯率表 ORDER BY 年 DESC, 月 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_匯率管理_查詢指定匯率()
        ConnOpen()
        SQL1 = "SELECT 買進匯率, 賣出匯率, 中心匯率, 美金匯率 FROM 歷史匯率表 WHERE (年 LIKE '" & 匯率管理.年_tb.Text & "%') AND (月 LIKE '" & 匯率管理.月_tb.Text & "%')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_匯率管理_修改匯率()
        ConnOpen()
        SQL1 = "UPDATE 歷史匯率表 SET 買進匯率 = '" & 匯率管理.買進匯率_tb.Text & "', 賣出匯率 = '" & 匯率管理.賣出匯率_tb.Text & "', 中心匯率 = '" & 匯率管理.目前匯率_tb.Text & "', 
                                      美金匯率 = '" & 匯率管理.美金匯率_tb.Text & "'  
                WHERE (年 LIKE '" & 匯率管理.年_tb.Text & "%') AND (月 LIKE '" & 匯率管理.月_tb.Text & "%')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_匯率管理_新增匯率()
        ConnOpen()
        SQL1 = "INSERT INTO 歷史匯率表 (年, 月, 買進匯率, 賣出匯率, 中心匯率, 美金匯率) VALUES ('" & 匯率管理.年_tb.Text & "','" & 匯率管理.月_tb.Text & "
                          ','" & 匯率管理.買進匯率_tb.Text & "', '" & 匯率管理.賣出匯率_tb.Text & "', '" & 匯率管理.目前匯率_tb.Text & "', '" & 匯率管理.美金匯率_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_匯率管理_查詢人民幣匯率()
        ConnOpen()
        SQL1 = "SELECT 匯率 FROM 匯率表 WHERE (對應 = '人民幣兌台幣')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_匯率管理_修改人民幣匯率()
        ConnOpen()
        SQL1 = "UPDATE 匯率表 SET 匯率 = '" & 匯率管理.目前匯率_tb.Text & "' WHERE (對應 = '人民幣兌台幣')"
        CmdSet_For_dr()
    End Sub
    '---------------------會計科目管理.------------------------------------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_會計科目管理_查詢會計科目()
        ConnOpen()
        SQL1 = "SELECT 第一階, 第二階, 會計科目, 編號, 層級, 英文名稱, 統制科目, 抵銷科目, 停用, 附註, 顯示 FROM  會計科目 WHERE 編號 LIKE N'" & 會計科目管理.ComboBox2.Text & "%' ORDER BY  編號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_會計科目管理_查詢第一階編號()
        ConnOpen()
        SQL1 = "SELECT 第一階, LEFT(編號, 4) AS 編號 FROM 會計科目 GROUP BY 第一階, LEFT(編號, 4) ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目管理_查詢第二階編號()
        ConnOpen()
        SQL1 = "SELECT LEFT(編號, 7) AS 編號, 第二階, 層級 FROM  會計科目 WHERE (LEFT(編號, 4) LIKE N'" & 會計科目管理.ComboBox2.Text & "') AND (層級 LIKE '" & 會計科目管理.ComboBox5.Text & "')
                GROUP BY   LEFT(編號, 7), 第二階, 層級 ORDER BY   編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目管理_查詢最後一筆編號1()
        ConnOpen()
        SQL1 = "SELECT TOP (1) LEFT(編號, 7) AS 編號 FROM  會計科目 WHERE (LEFT(編號, 4) LIKE '" & 會計科目管理.ComboBox2.Text & "') AND (層級 LIKE '2') 
                                GROUP BY   LEFT(編號, 7) ORDER BY   編號 DESC"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目管理_查詢最後一筆編號2()
        ConnOpen()
        SQL1 = "SELECT TOP (1) LEFT(編號, 10) AS 編號 FROM  會計科目 WHERE (LEFT(編號, 7) LIKE '" & 會計科目管理.ComboBox4.Text & "') AND (層級 LIKE '3') 
                                GROUP BY   LEFT(編號, 10) ORDER BY   編號 DESC"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目管理_修改會計科目()
        ConnOpen()
        SQL1 = "UPDATE 會計科目 SET 會計科目 = N'" & 會計科目管理.TextBox8.Text & "', 層級 = N'" & 會計科目管理.ComboBox6.Text & "', 
                                    英文名稱 = N'" & 會計科目管理.英文名稱_tb.Text & "', 統制科目 = N'" & 會計科目管理.統制科目_cb.Checked & "',   
                                    抵銷科目 = N'" & 會計科目管理.抵銷科目_cb.Checked & "', 停用 = N'" & 會計科目管理.停用_cb.Checked & "', 
                                    附註 = N'" & 會計科目管理.TextBox18.Text & "', 第一階 = N'" & 會計科目管理.ComboBox1.Text & "', 第二階 = N'" & 會計科目管理.ComboBox3.Text & "' , 
                                    顯示 = N'" & 會計科目管理.顯示_cb.Checked & "'
                WHERE 編號 LIKE N'" & 會計科目管理.TextBox16.Text & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目管理_刪除會計科目()
        ConnOpen()
        SQL1 = "DELETE FROM 會計科目 WHERE (編號 = N'" & 會計科目管理.TextBox16.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目管理_查詢會計科目編號()
        ConnOpen()
        SQL1 = "SELECT 編號 FROM 會計科目 WHERE 編號 LIKE '" & 會計科目管理.TextBox16.Text & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目管理_快速修改會計科目()
        ConnOpen()
        SQL1 = "UPDATE 會計科目 SET 會計科目 = N'" & PA1 & "', 層級 = N'" & PA2 & "', 英文名稱 = N'" & PA3 & "', 統制科目 = N'" & PA4 &
                                    "', 抵銷科目 = N'" & PA5 & "', 停用 = N'" & PA6 & "', 附註 = N'" & PA7 & "', 第一階 = N'" & PA8 &
                                    "', 第二階 = N'" & PA9 & "' , 顯示 = N'" & PA10 & "'
                WHERE  編號 LIKE N'" & PA11 & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目管理_新增會計科目編號1()
        ConnOpen()
        SQL1 = "INSERT INTO 會計科目 (會計科目, 編號, 層級, 英文名稱, 統制科目, 抵銷科目, 停用, 附註, 第一階, 第二階, 顯示) 
                                  VALUES (N'" & 會計科目管理.TextBox8.Text & "', N'" & 會計科目管理.TextBox16.Text & "', N'" & 會計科目管理.ComboBox6.Text & "', N'" & 會計科目管理.英文名稱_tb.Text &
                                      "', N'" & 會計科目管理.統制科目_cb.Checked & "', N'" & 會計科目管理.抵銷科目_cb.Checked & "', N'" & 會計科目管理.停用_cb.Checked & "', N'" & 會計科目管理.TextBox18.Text &
                                      "', N'" & 會計科目管理.TextBox8.Text & "', N'" & 會計科目管理.TextBox8.Text & "', N'" & 會計科目管理.顯示_cb.Checked & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目管理_新增會計科目編號2()
        ConnOpen()
        SQL1 = "INSERT INTO 會計科目 (會計科目, 編號, 層級, 英文名稱, 統制科目, 抵銷科目, 停用, 附註, 第一階, 第二階, 顯示) 
                                  VALUES (N'" & 會計科目管理.TextBox8.Text & "', N'" & 會計科目管理.TextBox16.Text & "', N'" & 會計科目管理.ComboBox6.Text & "', N'" & 會計科目管理.英文名稱_tb.Text &
                                      "', N'" & 會計科目管理.統制科目_cb.Checked & "', N'" & 會計科目管理.抵銷科目_cb.Checked & "', N'" & 會計科目管理.停用_cb.Checked & "', N'" & 會計科目管理.TextBox18.Text &
                                      "', N'" & 會計科目管理.ComboBox1.Text & "', N'" & 會計科目管理.TextBox8.Text & "', N'" & 會計科目管理.顯示_cb.Checked & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目管理_新增會計科目編號3()
        ConnOpen()
        SQL1 = "INSERT INTO 會計科目 (會計科目, 編號, 層級, 英文名稱, 統制科目, 抵銷科目, 停用, 附註, 第一階, 第二階, 顯示) 
                                  VALUES (N'" & 會計科目管理.TextBox8.Text & "', N'" & 會計科目管理.TextBox16.Text & "', N'" & 會計科目管理.ComboBox6.Text & "', N'" & 會計科目管理.英文名稱_tb.Text &
                                      "', N'" & 會計科目管理.統制科目_cb.Checked & "', N'" & 會計科目管理.抵銷科目_cb.Checked & "', N'" & 會計科目管理.停用_cb.Checked & "', N'" & 會計科目管理.TextBox18.Text &
                                      "', N'" & 會計科目管理.ComboBox1.Text & "', N'" & 會計科目管理.ComboBox3.Text & "', N'" & 會計科目管理.顯示_cb.Checked & "')"
        CmdSet_For_dr()
    End Sub
    '---------------------營運成本收支單申請.------------------------------------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_營運成本收支單申請_審核人1()
        PA20 = "WHERE (審核人 LIKE '') "
    End Sub
    Friend Sub SQL_營運成本收支單申請_審核人2()
        PA20 = "WHERE (審核人 LIKE '作廢%') "
    End Sub
    Friend Sub SQL_營運成本收支單申請_審核人3()
        PA20 = "WHERE (審核人 NOT LIKE '作廢%') AND (審核人 NOT LIKE '') "
    End Sub
    Friend Sub SQL_營運成本收支單申請_查詢公帳控制表()
        ConnOpen()
        SQL1 = "SELECT 支付單號 AS 收支單號, 申請日期, 審核日期, 申請人 FROM 公帳控制表 " & PA20 & " ORDER BY 申請日期 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單申請_查詢費用清單()
        ConnOpen()
        SQL1 = "SELECT      公帳流水帳.支付單號, 公帳流水帳.項次, 會計科目.會計科目, 公帳流水帳.明細 AS 用途, 
                            公帳流水帳.零用金, 公帳流水帳.支票數 AS 支票, Cast(公帳流水帳.收入 AS money) AS 收入, 
                            Cast(公帳流水帳.支出 AS money) AS 支出, 公帳流水帳.備註 AS 票期, 公帳流水帳.匯率, 
                            公帳流水帳.銀行 AS 幣別, 公帳流水帳.類別, 公帳流水帳.流水號, 公帳流水帳.含稅
                FROM        公帳流水帳 INNER JOIN
                            會計科目 ON 公帳流水帳.類別 = 會計科目.編號
                WHERE       (公帳流水帳.支付單號 LIKE '" & 財務_收支單申請.營運成本收支單號_tb.Text & "')
                ORDER BY    公帳流水帳.項次"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單申請_查詢公帳控制表會計科目()
        ConnOpen()
        SQL1 = "SELECT 會計科目, 編號 FROM 會計科目 WHERE (LEFT(編號, 7) LIKE N'" & 財務_收支單申請.ComboBox4.Text & "') AND (停用 = 0) AND (統制科目 = 0) ORDER BY 會計科目"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_查詢最後一筆公帳控制表會計科目()
        ConnOpen()
        SQL1 = "SELECT 第一階, LEFT(編號, 4) AS 編號 FROM 會計科目  WHERE (停用 = 0) GROUP BY 第一階, LEFT(編號, 4) ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_查詢最左邊公帳控制表會計科目()
        ConnOpen()
        SQL1 = "SELECT LEFT(編號, 7) AS 編號, 第二階, 層級 FROM  會計科目 WHERE (LEFT(編號, 4) LIKE N'" & 財務_收支單申請.ComboBox2.Text & "') AND (層級 NOT LIKE '3') AND (停用 = 0)
                GROUP BY   LEFT(編號, 7), 第二階, 層級 ORDER BY   編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_查詢匯率()
        ConnOpen()
        SQL1 = "SELECT 中心匯率, 美金匯率 FROM 歷史匯率表 
                WHERE (年 LIKE '" & PA1 & "%') AND (月 LIKE '" & PA2 & "%')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_營運成本會計科目查詢()
        ConnOpen()
        SQL1 = "SELECT 會計科目, 編號 FROM 會計科目 WHERE (會計科目 LIKE N'%" & 財務_收支單申請.關鍵字查詢會計科目_tb.Text & "%') AND (停用 = 0) AND (統制科目 = 0) ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目管理_修改收支單申請表()
        ConnOpen()
        SQL1 = "UPDATE 公帳流水帳 SET  明細 = N'" & PA1 & "', 支出 = N'" & PA2 & "', 項次 = N'" & PA9 & "', 
                       備註 = N'" & PA3 & "' , 類別 = N'" & PA4 & "', 收入 = N'" & PA5 & "',
                       零用金 = N'" & PA6 & "', 支票數 = N'" & PA7 & "', 匯率 = N'" & PA8 & "', 含稅 = N'" & BL1 & "'
                WHERE  (流水號 LIKE '" & PA10 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_查詢收支單公帳流水號()
        ConnOpen()
        SQL1 = "SELECT 流水號 FROM 公帳流水帳 WHERE (流水號 ='" & PA19 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_查詢第一筆公帳支付單號()
        ConnOpen()
        SQL1 = "SELECT TOP (1)  支付單號 FROM 公帳控制表 WHERE ( 支付單號 LIKE '" & PA & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_新增一筆公帳控制表()
        ConnOpen()
        SQL1 = "INSERT INTO 公帳控制表 (支付單號, 申請人, 申請日期, 審核人, 審核日期, 會計, 作帳日期, 出納, 出納日期, 備註, 公司編號) " &
               "VALUES (N'" & PA & "', N'" & gUserName & "', N'" & DTP4 & "', N'', N'', N'', N'', N'', N'', N'', N'雅邸家具')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_刪除公帳控制表_應收用()
        ConnOpen() : SQL1 = "DELETE FROM 公帳控制表 WHERE (支付單號 LIKE '" & PA & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_刪除公帳流水帳_應收用()
        ConnOpen() : SQL1 = "DELETE FROM 公帳流水帳 WHERE (支付單號 LIKE '" & PA & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目管理_開立零用金支付單()
        ConnOpen()
        SQL1 = "INSERT INTO 公帳流水帳 (流水號, 銀行, 日期, 類別, 收入, 支出, 明細, 人員, 支付單號, 項次, 會計, 出納, 現金, 備用金, 公帳, 支票, 
                            出納日期, 零用金, 支票數, 匯率, 備註) 
                    VALUES (N'" & PA19 & "', N'" & PA21 & "', N'" & DTP & "', N'" & PA22 & "', N'" & PA23 & "', N'" & PA24 & "', N'" & PA25 & "', '', 
                            N'" & gUserName & "', N'" & 財務_收支單申請.營運成本收支單號_tb.Text & "', N'" & PA26 & "', '1', '0', '0', '0', '0', '0', '" & DTP & "', N'" & PA27 & "', 
                            N'" & PA28 & "', N'" & PA29 & "', N'" & PA30 & "')"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單申請_刪除公帳控制表()
        ConnOpen()
        SQL1 = "DELETE FROM 公帳控制表 WHERE (支付單號 LIKE '" & 財務_收支單申請.營運成本收支單號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_刪除公帳流水帳()
        ConnOpen()
        SQL1 = "DELETE FROM 公帳流水帳 WHERE (支付單號 LIKE '" & 財務_收支單申請.營運成本收支單號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_刪除公帳流水帳支付單號()
        ConnOpen()
        SQL1 = "DELETE FROM 公帳流水帳 WHERE (支付單號 LIKE '" & 財務_收支單申請.營運成本收支單號_tb.Text & "' AND 項次 LIKE '" & 財務_收支單申請.選擇項次_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_修改公帳流水帳支付單號()
        ConnOpen()
        SQL1 = "UPDATE 公帳流水帳 SET 項次 = N'" & PA18 & "' WHERE (支付單號 LIKE '" & 財務_收支單申請.營運成本收支單號_tb.Text & "' AND 項次 LIKE '" & PA17 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_查詢最後一筆公帳支付單號()
        ConnOpen()
        SQL1 = "SELECT TOP(1) 項次 FROM 公帳流水帳 WHERE 支付單號 LIKE '" & PA & "' ORDER BY 項次 DESC"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_新增公帳流水帳資料()
        ConnOpen()
        SQL1 = "INSERT INTO 公帳流水帳 (流水號, 銀行, 日期, 類別, 收入, 支出, 明細, 人員, 支付單號, 項次, 會計, 出納, 現金, 備用金, 公帳, 支票, 
                            出納日期, 零用金, 支票數, 匯率, 備註, 含稅) " &
                   "VALUES (N'" & PA19 & "', N'" & 財務_收支單申請.幣別_cb.Text & "', N'" & DTP & "', N'" & 財務_收支單申請.ComboBox6.Text & "', N'0', N'0', N'', N'" & gUserName & "', N'" & 財務_收支單申請.營運成本收支單號_tb.Text & "', N'" & PA15 &
                        "', N'0', N'0', N'0', N'0', N'0', N'0', N'" & DTP & "', N'0', N'0', N'" & PA16 & "', N'' ,'0')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購應負帳款_新增公帳流水帳資料()
        ConnOpen()
        SQL1 = "INSERT INTO 公帳流水帳 (流水號, 銀行, 日期, 類別, 收入, 支出, 明細, 人員, 支付單號, 項次, 會計, 出納, 現金, 備用金, 公帳, 支票, 
                            出納日期, 零用金, 支票數, 匯率, 備註, 含稅) " &
                   "VALUES (N'" & PA19 & "', N'" & 採購應付帳款.幣別_cb.Text & "', N'" & DTP4 & "', N'" & 採購應付帳款.子會科編號_cb.Text & "', N'0', N'" & PA2 & "', 
                            N'" & PA1 & "-公司-[" & 採購應付帳款.開始日期_dtp.Value & "-" & 採購應付帳款.結束日期_dtp.Value & "]', N'" & gUserName & "', 
                            N'" & 採購應付帳款.營運成本收支單號_tb.Text & "', N'" & PA15 & "', N'0', N'0', N'0', N'0', N'0', N'0', N'" & DTP4 & "', N'0', N'0', N'" & PA16 & "', N'" & PA3 & "' ,'1')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購應負帳款_新增公帳流水帳資料1()
        ConnOpen()
        SQL1 = "INSERT INTO 公帳流水帳 (流水號, 銀行, 日期, 類別, 收入, 支出, 明細, 人員, 支付單號, 項次, 會計, 出納, 現金, 備用金, 公帳, 支票, 
                            出納日期, 零用金, 支票數, 匯率, 備註, 含稅) " &
                   "VALUES (N'" & PA19 & "', N'" & 採購應付帳款.幣別_cb.Text & "', N'" & DTP4 & "', N'" & 採購應付帳款.子會科編號_cb.Text & "', N'0', N'" & PA2 & "', 
                            N'" & PA1 & "-個人-[" & 採購應付帳款.開始日期_dtp.Value & "-" & 採購應付帳款.結束日期_dtp.Value & "]', N'" & gUserName & "', 
                            N'" & 採購應付帳款.營運成本收支單號_tb.Text & "', N'" & PA15 & "', N'0', N'0', N'0', N'0', N'0', N'0', N'" & DTP4 & "', N'0', N'0', N'" & PA16 & "', N'" & PA3 & "' ,'0')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_應收轉財務_新增公帳流水帳資料()
        ConnOpen()
        SQL1 = "INSERT INTO 公帳流水帳 (流水號, 銀行, 日期, 類別, 收入, 支出, 明細, 人員, 支付單號, 項次, 會計, 出納, 現金, 備用金, 公帳, 支票, 
                            出納日期, 零用金, 支票數, 匯率, 備註, 含稅) VALUES (N'" & PA19 & "', N'" & PA17 & "', N'" & DTP4 & "', N'" & PA18 & "', N'" & PA20 & "', 
                            N'" & PA22 & "', N'" & PA14 & "', N'" & gUserName & "', N'" & PA & "', N'" & PA15 & "', 
                            N'0', N'0', N'0', N'0', N'0', N'0', N'" & DTP4 & "', N'0', N'0', N'" & PA16 & "', N'' ,N'" & PA21 & "')"
        CmdSet_For_dr()
    End Sub
    '---------------------營運成本收支單審核.------------------------------------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_營運成本收支單審核_審核人1()
        PA = "WHERE (審核人 LIKE '') "
    End Sub
    Friend Sub SQL_營運成本收支單審核_審核人2()
        PA = "WHERE (審核人 LIKE '作廢%') "
    End Sub
    Friend Sub SQL_營運成本收支單審核_審核人3()
        ConnOpen()
        SQL1 = "UPDATE 公帳控制表 SET 審核人 = N'作廢-" & gUserName & "', 審核日期 = N'" & DTP & "', 備註 = N'" & PA & "' WHERE (支付單號 = N'" & 財務_收支單審核.營運成本收支單號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_查詢收支單審核()
        ConnOpen()
        SQL1 = "SELECT 支付單號 AS 收支單號, 申請日期, 審核日期, 申請人,備註 FROM 公帳控制表 " & PA & " ORDER BY 支付單號 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單審核_查詢費用清單()
        ConnOpen()
        SQL1 = "SELECT      公帳流水帳.支付單號, 公帳流水帳.項次, 會計科目.會計科目, 公帳流水帳.明細 AS 用途, 
                            Cast(公帳流水帳.零用金 AS money) AS 零用金, Cast(公帳流水帳.支票數 AS money) AS 支票, Cast(公帳流水帳.收入 AS money) AS 收入, 
                            Cast(公帳流水帳.支出 AS money) AS 支出, 公帳流水帳.備註 AS 票期, 公帳流水帳.匯率, 公帳流水帳.銀行 AS 幣別, 公帳流水帳.類別, 公帳流水帳.流水號, 公帳流水帳.含稅
                FROM        公帳流水帳 INNER JOIN
                            會計科目 ON 公帳流水帳.類別 = 會計科目.編號
                WHERE      (公帳流水帳.支付單號 LIKE '" & 財務_收支單審核.營運成本收支單號_tb.Text & "')
                ORDER BY    公帳流水帳.項次"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單審核_查詢圖片流水號()
        ConnOpen()
        SQL1 = "SELECT 圖片流水號 AS 圖檔編碼, 簽名檔人名 FROM YD主管簽名檔管理 ORDER BY 圖片流水號 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單審核_查詢簽名檔圖片()
        ConnOpen()
        SQL1 = "SELECT 簽名檔圖片 FROM YD主管簽名檔管理 WHERE 圖片流水號 LIKE '" & 財務_收支單審核.圖片編碼_tb.Text & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_查詢簽名編碼()
        ConnOpen()
        SQL1 = "SELECT 簽名編碼 FROM 公帳控制表 WHERE 簽名編碼 LIKE '" & 財務_收支單審核.驗證碼_tb.Text & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_修改公帳控制表()
        ConnOpen()
        SQL1 = "UPDATE 公帳控制表 SET 審核人 = N'" & PA & "', 審核日期 = N'" & DTP & "', 核准圖檔 = N'" & 財務_收支單審核.圖片編碼_tb.Text & "', 簽名編碼 = N'" &
                                                     財務_收支單審核.驗證碼_tb.Text & "', 出納 = '" & gUserName & "', 出納日期 = N'" & DTP & "'
                WHERE (支付單號 = N'" & 財務_收支單審核.營運成本收支單號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_修改公帳控制表_應負帳款用()
        ConnOpen()
        SQL1 = "UPDATE 公帳控制表 SET 審核人 = N'" & PA31 & "', 審核日期 = N'" & PA32 & "', 核准圖檔 = N'" & PA33 & "', 簽名編碼 = N'" & PA34 & "', 出納 = '" & PA35 & "', 出納日期 = N'" & PA36 & "'
                WHERE (支付單號 = N'" & 採購應付帳款.營運成本收支單號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_修改公帳流水帳()
        ConnOpen()
        SQL1 = "UPDATE 公帳流水帳 SET 出納 = '1', 出納日期 = N'" & DTP & "'
                WHERE (支付單號 LIKE '" & 財務_收支單審核.營運成本收支單號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_修改公帳流水帳_應付帳款用()
        ConnOpen()
        SQL1 = "UPDATE 公帳流水帳 SET 出納 = '1', 出納日期 = N'" & DTP & "'
                WHERE (支付單號 LIKE '" & 採購應付帳款.營運成本收支單號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_修改公帳流水帳備用金()
        ConnOpen()
        SQL1 = "UPDATE 公帳流水帳 SET  備用金 = N'1' WHERE (支付單號 LIKE '" & 財務_收支單審核.營運成本收支單號_tb.Text & "' AND 項次 LIKE '" & PA1 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_修改公帳流水帳現金()
        ConnOpen()
        SQL1 = "UPDATE 公帳流水帳 SET  現金 = N'1' WHERE (支付單號 LIKE '" & 財務_收支單審核.營運成本收支單號_tb.Text & "' AND 項次 LIKE '" & PA1 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_修改公帳流水帳支出()
        ConnOpen()
        SQL1 = "UPDATE 公帳流水帳 SET  公帳 = N'1' WHERE (支付單號 LIKE '" & 財務_收支單審核.營運成本收支單號_tb.Text & "' AND 項次 LIKE '" & PA1 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_修改公帳流水帳支出_應付帳款用()
        ConnOpen()
        SQL1 = "UPDATE 公帳流水帳 SET  公帳 = N'1' WHERE (支付單號 LIKE '" & 採購應付帳款.營運成本收支單號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    '---------------------營運成本收支單一覽表.-------------------------------------------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_營運成本收支單一覽表_查詢清單純日期()
        ConnOpen()
        SQL1 = "SELECT 申請日期 FROM 公帳控制表 
                WHERE (審核人 NOT LIKE '作廢%') AND 申請日期 
                       BETWEEN '" & Strings.Format(財務_收支單一覽表.開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Strings.Format(財務_收支單一覽表.結束日期_dtp.Value, "yyyy/MM/dd") & "'
                GROUP BY 申請日期
                ORDER BY 申請日期 DESC"
        '(審核人 NOT LIKE '') AND 
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單一覽表_查詢清單()
        ConnOpen()
        SQL1 = "SELECT 支付單號 AS 收支單號, 申請人, 申請日期, 審核人, 審核日期, 核准圖檔,  簽名編碼 FROM 公帳控制表 
                WHERE (審核人 NOT LIKE '作廢%') AND 
                申請日期 BETWEEN '" & Strings.Format(財務_收支單一覽表.開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Strings.Format(財務_收支單一覽表.結束日期_dtp.Value, "yyyy/MM/dd") & "'
                ORDER BY 申請日期 DESC"
        '(審核人 NOT LIKE '') AND 
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單一覽表_查詢清單2()
        ConnOpen()
        SQL1 = "SELECT      LEFT(公帳控制表.申請日期, 4) AS 日期, 會計科目.第一階 AS 主項, 會計科目.第二階 AS 子項, 
                            會計科目.會計科目 AS 子細項, SUM(公帳流水帳.零用金) AS 零用金, SUM(公帳流水帳.支票數) 
                            AS 支票, SUM(Cast(公帳流水帳.收入 AS money)) AS 收入, SUM(Cast(公帳流水帳.支出 AS money)) AS 支出, 公帳流水帳.銀行 AS 幣別, 公帳流水帳.匯率
                FROM        公帳控制表 RIGHT OUTER JOIN
                            公帳流水帳 ON 公帳控制表.支付單號 = 公帳流水帳.支付單號 RIGHT OUTER JOIN
                            會計科目 ON 公帳流水帳.類別 = 會計科目.編號
                WHERE      (公帳控制表.申請日期 BETWEEN '" & Strings.Format(財務_收支單一覽表.開始日期_dtp.Value, "yyyy/MM/dd") & "' 
                            AND '" & Strings.Format(財務_收支單一覽表.結束日期_dtp.Value, "yyyy/MM/dd") & "') " & SQL2 & "
                GROUP BY    會計科目.第一階, 會計科目.第二階, 會計科目.會計科目, LEFT(會計科目.編號, 7), 
                            LEFT(公帳控制表.申請日期, 4), 公帳流水帳.銀行, 公帳流水帳.匯率
                ORDER BY    幣別, LEFT(公帳控制表.申請日期, 4), LEFT(會計科目.編號, 7)"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單一覽表_查詢清單3()
        ConnOpen()
        SQL1 = "SELECT      LEFT(公帳控制表.申請日期, 4) AS 日期, 會計科目.第一階 AS 主項, 會計科目.第二階 AS 子項, 
                            會計科目.會計科目 AS 子細項, SUM(公帳流水帳.零用金) AS 零用金, SUM(公帳流水帳.支票數) 
                            AS 支票, SUM(Cast(公帳流水帳.收入 AS money)) AS 收入, SUM(Cast(公帳流水帳.支出 AS money)) AS 支出, 公帳流水帳.銀行 AS 幣別, 公帳流水帳.匯率
                FROM        公帳控制表 RIGHT OUTER JOIN
                            公帳流水帳 ON 公帳控制表.支付單號 = 公帳流水帳.支付單號 RIGHT OUTER JOIN
                            會計科目 ON 公帳流水帳.類別 = 會計科目.編號
                WHERE      (公帳控制表.申請日期 BETWEEN '" & Strings.Format(財務_收支單一覽表.申請日期_dtp.Value, "yyyy/MM/dd") & "' 
                            AND '" & Strings.Format(財務_收支單一覽表.申請日期_dtp.Value, "yyyy/MM/dd") & "') " & SQL2 & "
                GROUP BY    會計科目.第一階, 會計科目.第二階, 會計科目.會計科目, LEFT(會計科目.編號, 7), 
                            LEFT(公帳控制表.申請日期, 4), 公帳流水帳.銀行, 公帳流水帳.匯率
                ORDER BY    幣別, LEFT(公帳控制表.申請日期, 4), LEFT(會計科目.編號, 7)"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單一覽表_查詢費用清單()
        ConnOpen()
        SQL1 = "SELECT      公帳流水帳.支付單號, 公帳流水帳.項次, 會計科目.會計科目, 公帳流水帳.明細 AS 用途, 
                            Cast(公帳流水帳.零用金 AS money) AS 零用金, Cast(公帳流水帳.支票數 AS money) AS 支票, Cast(公帳流水帳.收入 AS money) AS 收入, 
                            Cast(公帳流水帳.支出 AS money) AS 支出, 公帳流水帳.備註 AS 票期, 公帳流水帳.匯率, 公帳流水帳.銀行 AS 幣別, 公帳流水帳.類別, 公帳流水帳.流水號
                FROM        公帳流水帳 INNER JOIN
                            會計科目 ON 公帳流水帳.類別 = 會計科目.編號 INNER JOIN
                            公帳控制表 ON 公帳流水帳.支付單號 = 公帳控制表.支付單號
                WHERE      (公帳控制表.申請日期 LIKE '" & 財務_收支單一覽表.申請日期_dtp.Text & "') " & SQL2 & "
                ORDER BY    公帳流水帳.項次"
        ' WHERE      (公帳流水帳.支付單號 LIKE '" & 財務_收支單一覽表.收支單號_tb.Text & "') " & SQL2 & "
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單一覽表_查詢簽名檔圖片()
        ConnOpen()
        SQL1 = "SELECT 簽名檔圖片 FROM YD主管簽名檔管理 WHERE 圖片流水號 LIKE '" & 財務_收支單一覽表.圖片編碼_tb.Text & "'"
        CmdSet_For_dr()
    End Sub
    '---------------------營運成本收支單_對帳表.----------------------------------------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_剔除存檔新增()
        ConnOpen() : SQL1 = "INSERT INTO  剔除會科存檔 (剔除會科) VALUES (N'" & PA1 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_剔除存檔比對()
        ConnOpen() : SQL1 = "SELECT  剔除會科  FROM  剔除會科存檔 WHERE 剔除會科 LIKE N'" & PA1 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_剔除存檔()
        ConnOpen() : SQL1 = "SELECT  剔除會科  FROM  剔除會科存檔" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_剔除會科()
        ConnOpen()
        SQL1 = "SELECT    系統選擇按鈕.選擇, QQ.會計科目, QQ.類別, YD客製報表2.現金 AS 金額
                FROM      系統選擇按鈕 LEFT OUTER JOIN YD客製報表2 ON 系統選擇按鈕.選擇 = YD客製報表2.流水號 RIGHT OUTER JOIN
                         (SELECT    TOP (100) PERCENT 會計科目.會計科目, 公帳流水帳.類別
                          FROM      公帳流水帳 INNER JOIN 會計科目 ON 公帳流水帳.類別 = 會計科目.編號 INNER JOIN 
                                    公帳控制表 ON 公帳流水帳.支付單號 = 公帳控制表.支付單號
                          WHERE    (公帳控制表.審核日期 LIKE '" & PA & "%')
                          GROUP BY  會計科目.會計科目, 公帳流水帳.類別
                          ORDER BY    公帳流水帳.類別) AS QQ ON 系統選擇按鈕.按鈕 = QQ.會計科目"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單對帳表()
        ConnOpen()
        SQL1 = "SELECT      公帳控制表.支付單號 AS 收支單號, 公帳控制表.申請人, 公帳控制表.申請日期, 公帳控制表.審核人, 
                            公帳控制表.審核日期, 公帳流水帳.項次, 會計科目.會計科目, 公帳流水帳.明細 AS 用途與內容, 
                            公帳流水帳.零用金, 公帳流水帳.支票數 AS 支票, Cast(公帳流水帳.收入 AS money) AS 收入, 
                            Cast(公帳流水帳.支出 AS money) AS 支出, 公帳流水帳.備註, 公帳流水帳.會計, 公帳流水帳.日期 AS 作帳日期, 
                            公帳流水帳.出納 AS 點交, 公帳流水帳.出納日期 AS 點交日期, 公帳流水帳.備用金 AS 零用金點交, 
                            公帳流水帳.支票 AS 支票兌現, 公帳流水帳.現金 AS 現金點交, 公帳流水帳.公帳 AS 支出點交, 公帳流水帳.匯率, 公帳流水帳.銀行 AS 幣別
                FROM        公帳流水帳 INNER JOIN
                            會計科目 ON 公帳流水帳.類別 = 會計科目.編號 FULL OUTER JOIN
                            公帳控制表 ON 公帳流水帳.支付單號 = 公帳控制表.支付單號
                WHERE      (公帳控制表.審核人 NOT LIKE '作廢%') AND (公帳流水帳.匯率 IS NOT NULL) " & PA20 & PA19 & PA18 & SQL2 & " 
                ORDER BY    收支單號 DESC, 公帳流水帳.項次"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單對帳表_查詢最後一筆年份清單()
        ConnOpen() : SQL1 = "SELECT  年份 FROM 年份清單 ORDER BY 年份 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單對帳表_修改會計()
        ConnOpen() : SQL1 = "UPDATE 公帳流水帳 SET 會計 = N'0' WHERE (會計 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單對帳表_修改出納()
        ConnOpen() : SQL1 = "UPDATE 公帳流水帳 SET 出納 = N'0' WHERE (出納 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單對帳表_修改現金()
        ConnOpen() : SQL1 = "UPDATE 公帳流水帳 SET 現金 = N'0' WHERE (現金 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單對帳表_修改備用金()
        ConnOpen() : SQL1 = "UPDATE 公帳流水帳 SET 備用金 = N'0' WHERE (備用金 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單對帳表_修改公帳()
        ConnOpen() : SQL1 = "UPDATE 公帳流水帳 SET 公帳 = N'0' WHERE (公帳 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單對帳表_修改支票()
        ConnOpen() : SQL1 = "UPDATE 公帳流水帳 SET 支票 = N'0' WHERE (支票 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單對帳表_修改日期()
        ConnOpen() : SQL1 = "UPDATE 公帳流水帳 SET 日期 = N'' WHERE (日期 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單對帳表_修改出納日期()
        ConnOpen() : SQL1 = "UPDATE 公帳流水帳 SET 出納日期 = N'' WHERE (出納日期 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單對帳表_修改對帳記錄存檔()
        ConnOpen()
        SQL1 = "UPDATE 公帳流水帳 SET 現金 = '" & PA15 & "', 備用金 = '" & PA14 & "', 
                                      公帳 = '" & PA13 & "', 支票 = '" & PA12 & "' 
                WHERE  支付單號   LIKE       '" & PA11 & "' AND 項次 Like '" & PA10 & "'"
        CmdSet_For_dr()
    End Sub
    '---------------------營運報表.-------------------------------------------------------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_營運報表_年份查詢()
        ConnOpen() : SQL1 = "SELECT  年份 FROM 年份清單 ORDER BY 年份 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運報表_查詢清單()
        ConnOpen()
        SQL1 = "SELECT      會計科目.層級, 會計科目.第一階, 會計科目.第二階, 會計科目.第一階 AS 主項, 會計科目.第二階 AS 子項, 會計科目.會計科目 AS 子細項, QQWW.主項金額, WWEE.子項金額, 
                            EERR.細項金額
                FROM        會計科目 FULL OUTER JOIN
                               (SELECT 公帳流水帳_3.類別 AS 細項, SUM(Cast(公帳流水帳_3.收入 AS money) * (公帳流水帳_3.匯率)) - SUM(Cast(公帳流水帳_3.支出 AS money) * (公帳流水帳_3.匯率)) 
                                       AS 細項金額
                                FROM   公帳流水帳 AS 公帳流水帳_3 INNER JOIN 公帳控制表 AS 公帳控制表_3 ON 公帳流水帳_3.支付單號 = 公帳控制表_3.支付單號 INNER JOIN
                                       會計科目 AS 會計科目_3 ON 公帳流水帳_3.類別 = 會計科目_3.編號
                                WHERE (LEFT(公帳控制表_3. " & 財務_決算表.計算基礎_ch.Text & ",4) LIKE N'" & 財務_決算表.年份_cb.Text & "') " & SQL4 & "
                                GROUP BY    公帳流水帳_3.類別) AS EERR ON 會計科目.編號 = EERR.細項 
                            FULL OUTER JOIN
                               (SELECT LEFT(公帳流水帳_2.類別, 4) AS 主碼, SUM(公帳流水帳_2.零用金 * (公帳流水帳_2.匯率)) + SUM(公帳流水帳_2.支票數 * (公帳流水帳_2.匯率)) + 
                                       SUM(Cast(公帳流水帳_2.收入 AS money) * (公帳流水帳_2.匯率)) - SUM(Cast(公帳流水帳_2.支出 AS money) * (公帳流水帳_2.匯率)) AS 主項金額
                                FROM   公帳流水帳 AS 公帳流水帳_2 INNER JOIN 公帳控制表 AS 公帳控制表_2 ON 公帳流水帳_2.支付單號 = 公帳控制表_2.支付單號 INNER JOIN
                                       會計科目 AS 會計科目_2 ON 公帳流水帳_2.類別 = 會計科目_2.編號
                                WHERE (LEFT(公帳控制表_2. " & 財務_決算表.計算基礎_ch.Text & ",4) LIKE N'" & 財務_決算表.年份_cb.Text & "') " & SQL3 & "
                                GROUP BY    LEFT(公帳流水帳_2.類別, 4)) AS QQWW ON LEFT(會計科目.編號, 4) = QQWW.主碼 
                            FULL OUTER JOIN
                               (SELECT LEFT(公帳流水帳_1.類別, 7) AS 子碼, SUM(公帳流水帳_1.零用金 * (公帳流水帳_1.匯率)) + SUM(公帳流水帳_1.支票數 * (公帳流水帳_1.匯率)) + 
                                       SUM(Cast(公帳流水帳_1.收入 AS money) * (公帳流水帳_1.匯率)) - SUM(Cast(公帳流水帳_1.支出 AS money) * (公帳流水帳_1.匯率)) AS 子項金額
                                FROM   公帳流水帳 AS 公帳流水帳_1 INNER JOIN 公帳控制表 AS 公帳控制表_1 ON 公帳流水帳_1.支付單號 = 公帳控制表_1.支付單號 INNER JOIN
                                       會計科目 AS 會計科目_1 ON 公帳流水帳_1.類別 = 會計科目_1.編號
                                WHERE (LEFT(公帳控制表_1. " & 財務_決算表.計算基礎_ch.Text & ",4) LIKE N'" & 財務_決算表.年份_cb.Text & "') " & SQL2 & "
                                GROUP BY    LEFT(公帳流水帳_1.類別, 7)) AS WWEE ON LEFT(會計科目.編號, 7) = WWEE.子碼
                WHERE     (會計科目.顯示 = 1)
                ORDER BY   LEFT(會計科目.編號, 1) DESC, 會計科目.編號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運報表_查詢單月份清單()
        ConnOpen()
        SQL1 = "SELECT      會計科目.層級, 會計科目.第一階, 會計科目.第二階, 會計科目.第一階 AS 主項, 會計科目.第二階 AS 子項, 會計科目.會計科目 AS 子細項, QQWW.主項金額, WWEE.子項金額, 
                            EERR.細項金額, EERR.細項金額 AS [金額]
                FROM        會計科目 FULL OUTER JOIN
                               (SELECT 公帳流水帳_3.類別 AS 細項, SUM(Cast(公帳流水帳_3.收入 AS money) * (公帳流水帳_3.匯率)) - SUM(Cast(公帳流水帳_3.支出 AS money) * (公帳流水帳_3.匯率)) 
                                       AS 細項金額
                                FROM   公帳流水帳 AS 公帳流水帳_3 INNER JOIN 公帳控制表 AS 公帳控制表_3 ON 公帳流水帳_3.支付單號 = 公帳控制表_3.支付單號 INNER JOIN
                                       會計科目 AS 會計科目_3 ON 公帳流水帳_3.類別 = 會計科目_3.編號
                                WHERE (LEFT(公帳控制表_3. " & 財務_決算表.計算基礎_ch.Text & ",7) LIKE N'" & 財務_決算表.年份_cb.Text & "/" & PA36 & "') AND (會計科目_3.顯示 = 1) " & SQL4 & "
                                GROUP BY    公帳流水帳_3.類別) AS EERR ON 會計科目.編號 = EERR.細項 
                            FULL OUTER JOIN
                               (SELECT LEFT(公帳流水帳_2.類別, 4) AS 主碼, SUM(公帳流水帳_2.零用金 * (公帳流水帳_2.匯率)) + SUM(公帳流水帳_2.支票數 * (公帳流水帳_2.匯率)) + 
                                       SUM(Cast(公帳流水帳_2.收入 AS money) * (公帳流水帳_2.匯率)) - SUM(Cast(公帳流水帳_2.支出 AS money) * (公帳流水帳_2.匯率)) AS 主項金額
                                FROM   公帳流水帳 AS 公帳流水帳_2 INNER JOIN 公帳控制表 AS 公帳控制表_2 ON 公帳流水帳_2.支付單號 = 公帳控制表_2.支付單號 INNER JOIN
                                       會計科目 AS 會計科目_2 ON 公帳流水帳_2.類別 = 會計科目_2.編號
                                WHERE (LEFT(公帳控制表_2. " & 財務_決算表.計算基礎_ch.Text & ",7) LIKE N'" & 財務_決算表.年份_cb.Text & "/" & PA36 & "') AND (會計科目_2.顯示 = 1) " & SQL3 & "
                                GROUP BY    LEFT(公帳流水帳_2.類別, 4)) AS QQWW ON LEFT(會計科目.編號, 4) = QQWW.主碼 
                            FULL OUTER JOIN
                               (SELECT LEFT(公帳流水帳_1.類別, 7) AS 子碼, SUM(公帳流水帳_1.零用金 * (公帳流水帳_1.匯率)) + SUM(公帳流水帳_1.支票數 * (公帳流水帳_1.匯率)) + 
                                       SUM(Cast(公帳流水帳_1.收入 AS money) * (公帳流水帳_1.匯率)) - SUM(Cast(公帳流水帳_1.支出 AS money) * (公帳流水帳_1.匯率)) AS 子項金額
                                FROM   公帳流水帳 AS 公帳流水帳_1 INNER JOIN 公帳控制表 AS 公帳控制表_1 ON 公帳流水帳_1.支付單號 = 公帳控制表_1.支付單號 INNER JOIN
                                       會計科目 AS 會計科目_1 ON 公帳流水帳_1.類別 = 會計科目_1.編號
                                WHERE (LEFT(公帳控制表_1. " & 財務_決算表.計算基礎_ch.Text & ",7) LIKE N'" & 財務_決算表.年份_cb.Text & "/" & PA36 & "') AND (會計科目_1.顯示 = 1) " & SQL2 & "
                                GROUP BY    LEFT(公帳流水帳_1.類別, 7)) AS WWEE ON LEFT(會計科目.編號, 7) = WWEE.子碼
                WHERE     (會計科目.顯示 = 1)
                ORDER BY   LEFT(會計科目.編號, 1) DESC, 會計科目.編號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運報表_查詢會計科目()
        ConnOpen()
        SQL1 = "SELECT      會計科目.層級, 會計科目.第一階, 會計科目.第二階, 會計科目.第一階 AS 主項, 會計科目.第二階 AS 子項, 會計科目.會計科目 AS 子細項, QQWW.主項金額, WWEE.子項金額, 
                            EERR.細項金額
                FROM        會計科目 FULL OUTER JOIN
                               (SELECT 公帳流水帳_3.類別 AS 細項, SUM(Cast(公帳流水帳_3.收入 AS money) * (公帳流水帳_3.匯率)) - SUM(Cast(公帳流水帳_3.支出 AS money) * (公帳流水帳_3.匯率)) 
                                       AS 細項金額
                                FROM   公帳流水帳 AS 公帳流水帳_3 INNER JOIN 公帳控制表 AS 公帳控制表_3 ON 公帳流水帳_3.支付單號 = 公帳控制表_3.支付單號
                                GROUP BY    公帳流水帳_3.類別) AS EERR ON 會計科目.編號 = EERR.細項 
                            FULL OUTER JOIN
                               (SELECT LEFT(公帳流水帳_2.類別, 4) AS 主碼, SUM(公帳流水帳_2.零用金 * (公帳流水帳_2.匯率)) + SUM(公帳流水帳_2.支票數 * (公帳流水帳_2.匯率)) + 
                                       SUM(Cast(公帳流水帳_2.收入 AS money) * (公帳流水帳_2.匯率)) - SUM(Cast(公帳流水帳_2.支出 AS money) * (公帳流水帳_2.匯率)) AS 主項金額
                                FROM   公帳流水帳 AS 公帳流水帳_2 INNER JOIN 公帳控制表 AS 公帳控制表_2 ON 公帳流水帳_2.支付單號 = 公帳控制表_2.支付單號
                                GROUP BY    LEFT(公帳流水帳_2.類別, 4)) AS QQWW ON LEFT(會計科目.編號, 4) = QQWW.主碼 
                            FULL OUTER JOIN
                               (SELECT LEFT(公帳流水帳_1.類別, 7) AS 子碼, SUM(公帳流水帳_1.零用金 * (公帳流水帳_1.匯率)) + SUM(公帳流水帳_1.支票數 * (公帳流水帳_1.匯率)) + 
                                       SUM(Cast(公帳流水帳_1.收入 AS money) * (公帳流水帳_1.匯率)) - SUM(Cast(公帳流水帳_1.支出 AS money) * (公帳流水帳_1.匯率)) AS 子項金額
                                FROM   公帳流水帳 AS 公帳流水帳_1 INNER JOIN 公帳控制表 AS 公帳控制表_1 ON 公帳流水帳_1.支付單號 = 公帳控制表_1.支付單號
                                GROUP BY    LEFT(公帳流水帳_1.類別, 7)) AS WWEE ON LEFT(會計科目.編號, 7) = WWEE.子碼
                WHERE     (會計科目.顯示 = 1)
                ORDER BY   LEFT(會計科目.編號, 1) DESC, 會計科目.編號"
        CmdSet_For_DGV()
    End Sub
    '---------------------匯入EXCEL.------------------------------------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_薪資轉帳表_流水號_最後一筆資料()
        ConnOpen() : SQL1 = "SELECT TOP (1) 流水號 FROM 薪資轉帳表 ORDER BY 流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_薪資轉帳表_匯入EXCEL_新增(ByVal NoColumns As Integer)
        ConnOpen()
        SQL1 = "INSERT INTO 薪資轉帳表 (流水號, 姓名, 身分證, 結算日期, 獎金, 薪資, 領現, 薪資合計, 領現合計, 給付方式, 人事資料流水號) 
                VALUES (N'" & 匯入EXCEL.流水號_tb.Text & "', N'" & 匯入EXCEL.薪資匯入EXCEL_dgv(7, NoColumns).Value & "',
                        N'" & 匯入EXCEL.薪資匯入EXCEL_dgv(2, NoColumns).Value & "', N'" & 匯入EXCEL.薪資匯入EXCEL_dgv(8, NoColumns).Value & "',
                        N'" & 匯入EXCEL.薪資匯入EXCEL_dgv(3, NoColumns).Value & "', N'" & 匯入EXCEL.薪資匯入EXCEL_dgv(4, NoColumns).Value & "', 
                        N'" & 匯入EXCEL.薪資匯入EXCEL_dgv(5, NoColumns).Value & "', N'" & 匯入EXCEL.薪資匯入EXCEL_dgv(6, NoColumns).Value & "', 
                        N'" & 匯入EXCEL.薪資匯入EXCEL_dgv(5, NoColumns).Value & "', N'" & 匯入EXCEL.薪資匯入EXCEL_dgv(9, NoColumns).Value & "', 
                        N'" & 匯入EXCEL.人事流水號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    '---------------------匯出EXCEL.------------------------------------------------------------------------------------------------------------------------------------------
    Friend Sub 薪資轉帳表_匯出EXCEL_月份清單(ByVal Str_Date As String)
        ConnOpen()
        SQL1 = "SELECT      薪資轉帳表.流水號, 人事資料表.舊編, 人事資料表.薪資帳號, 人事資料表.身分證, 薪資轉帳表.獎金, 薪資轉帳表.薪資, 
                            薪資轉帳表.領現, 薪資轉帳表.薪資合計, 人事資料表.姓名, 薪資轉帳表.結算日期, 薪資轉帳表.給付方式, 薪資轉帳表.人事資料流水號
                FROM        薪資轉帳表  LEFT OUTER JOIN
                            人事資料表 ON 薪資轉帳表.人事資料流水號 = 人事資料表.流水號
                WHERE      (薪資轉帳表.結算日期 NOT LIKE '')  
                           AND (薪資轉帳表.結算日期 LIKE '" & Str_Date & "%" & "')
               ORDER BY    薪資轉帳表.流水號"
        CmdSet_For_DGV()
    End Sub
    '---------------------薪資轉帳.------------------------------------------------------------------------------------------------------------------------------------------
    Friend Sub 薪資轉帳表_月份清單()
        ConnOpen()
        SQL1 = "SELECT      薪資轉帳表.流水號, 人事資料表.姓名, 人事資料表.身分證, 薪資轉帳表.結算日期, 薪資轉帳表.獎金, 薪資轉帳表.薪資, 薪資轉帳表.領現, 
                            薪資轉帳表.薪資合計, 薪資轉帳表.領現合計, 薪資轉帳表.給付方式, 薪資轉帳表.人事資料流水號, 
                            人事資料表.薪資帳號, 人事資料表.職務, 人事資料表.電話, 人事資料表.手機
                FROM        薪資轉帳表  LEFT OUTER JOIN
                            人事資料表 ON 薪資轉帳表.人事資料流水號 = 人事資料表.流水號
                WHERE      (薪資轉帳表.結算日期 NOT LIKE '')  
                           AND (薪資轉帳表.結算日期 LIKE '" & Strings.Left(Format(薪資轉帳表.結束日期_dtp.Value, "yyyy/MM/dd"), 8) & "%" & "')
               ORDER BY    薪資轉帳表.流水號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub 薪資轉帳表_姓名選擇()
        ConnOpen() : SQL1 = "SELECT  姓名 FROM 人事資料表 GROUP BY 姓名" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_薪資轉帳表_新增()
        ConnOpen()
        SQL1 = "INSERT INTO 薪資轉帳表 (流水號, 身分證, 結算日期, 獎金, 薪資, 領現, 薪資合計, 領現合計, 給付方式, 人事資料流水號) 
                VALUES (N'" & 薪資轉帳表.流水號_tb.Text & "', N'" & 薪資轉帳表.身分證_tb.Text & "', N'" & 薪資轉帳表.結束日期_dtp.Value.ToString("yyyy/MM/dd") & "', 
                        N'', N'', N'', N'', N'', N'', N'" & 薪資轉帳表.人事流水號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_薪資轉帳表_修改()
        ConnOpen()
        SQL1 = "UPDATE 薪資轉帳表 SET 結算日期 = N'" & 薪資轉帳表.結束日期_dtp.Value.ToString("yyyy/MM/dd") & "', 姓名 = N'" & 薪資轉帳表.姓名_cb.Text & "',
                                      身分證 = N'" & 薪資轉帳表.身分證_tb.Text & "', 獎金 = N'" & 薪資轉帳表.獎金_tb.Text & "',
                                      薪資 = N'" & 薪資轉帳表.薪資_tb.Text & "', 領現 = N'" & 薪資轉帳表.領現_tb.Text & "', 
                                      薪資合計 = N'" & 薪資轉帳表.薪資總金額_tb.Text & "', 領現合計 = N'" & 薪資轉帳表.領現總金額_tb.Text & "',
                                      給付方式 = N'" & 薪資轉帳表.給付方式_cb.Text & "', 人事資料流水號 = N'" & 薪資轉帳表.人事流水號_tb.Text & "'
                        WHERE (流水號 LIKE N'" & 薪資轉帳表.流水號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_薪資轉帳表_刪除()
        ConnOpen() : SQL1 = "DELETE 薪資轉帳表 WHERE (流水號 = N'" & 薪資轉帳表.流水號_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_公帳控制表_備註()
        ConnOpen() : SQL1 = "SELECT  備註 FROM 公帳控制表 WHERE " & PA & "" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL採購應負帳款_查詢明細()
        ConnOpen() : SQL1 = "SELECT 支付單號 FROM 公帳流水帳 
                              WHERE  明細 LIKE N'%" & 採購應付帳款.開始日期_dtp.Value & "-" & 採購應付帳款.結束日期_dtp.Value & "%'  
                              GROUP BY   支付單號 "
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL採購應負帳款_查詢審核狀態()
        ConnOpen()
        SQL1 = "SELECT 審核人, 審核日期, 核准圖檔, 簽名編碼, 出納, 出納日期 FROM 公帳控制表 WHERE  (支付單號 LIKE N'" & 採購應付帳款.營運成本收支單號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL採購轉財務_刪除控制表()
        ConnOpen() : SQL1 = "DELETE 公帳控制表 WHERE (支付單號 = N'" & 採購應付帳款.營運成本收支單號_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL採購轉財務_刪除流水帳()
        ConnOpen() : SQL1 = "DELETE 公帳流水帳 WHERE (支付單號 = N'" & 採購應付帳款.營運成本收支單號_tb.Text & "')" : CmdSet_For_dr()
    End Sub

    '---------------------高層客製報表.------------------------------------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_今日簽單()
        ConnOpen()
        SQL1 = "SELECT 日期, 類別, A1 AS 訂編, A2 AS 客戶姓名, A3 AS 簽單金額, A4 AS 現金, A5 AS 匯款, A6 AS 刷卡, A7 AS 支票, A8 AS 備註, 流水號
                FROM   YD客製報表1 WHERE (日期 LIKE '" & PA & "') AND (類別 = 'A') ORDER BY A1"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_今日送貨()
        ConnOpen()
        SQL1 = "SELECT 日期, 類別, A1 AS 訂編, A2 AS 客戶姓名, A3 AS 出貨金額, A4 AS 應收已收, A5 AS [匯款/收現], A6 AS [支票/刷卡], A7 AS 應收未收, A8 AS 備註, 流水號
                FROM   YD客製報表1 WHERE (日期 LIKE '" & PA & "') AND (類別 = 'B') ORDER BY A1"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_今日支出()
        ConnOpen()
        SQL1 = "SELECT 日期, 類別, A1 AS 收支單號, A2 AS 會計科目, A3 AS 用途, A4 AS 零用金, A5 AS 支票, A6 AS 收入, A7 AS 支出, A8 AS [票期/備註], 流水號
                FROM   YD客製報表1 WHERE (日期 LIKE '" & PA & "') AND (類別 = 'C') ORDER BY A1"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_今日結算()
        ConnOpen()
        SQL1 = "SELECT 日期, 流水號, 銀行, 狀態, 前日結存, 現金, 匯款, [刷卡/支票], 支出, 支出 AS [支出(不含刷卡)], 備註, 當日結存
                FROM   YD客製報表2
                WHERE (日期 LIKE '" & PA & "') ORDER BY 銀行"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_客製表1_新增()
        ConnOpen()
        SQL1 = "INSERT INTO YD客製報表1 (日期, 類別, A1, A2, A3, A4, A5, A6, A7, A8, 流水號) 
                VALUES (N'" & PA & "', N'" & 類別 & "', N'" & PA2 & "', N'', N'', N'', N'', N'', N'', N'', N'" & PA1 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_客製表1_最後一筆資料()
        ConnOpen() : SQL1 = "SELECT TOP (1) 流水號 FROM YD客製報表1 ORDER BY 流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_客製表1_刪除()
        ConnOpen() : SQL1 = "DELETE YD客製報表1 WHERE 流水號 LIKE N'" & PA1 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_客製表2_最後一筆資料()
        ConnOpen() : SQL1 = "SELECT TOP (1) 流水號 FROM YD客製報表2 ORDER BY 流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_客製表2_新增()
        ConnOpen()
        SQL1 = "INSERT INTO YD客製報表2 (日期, 流水號, 銀行, 狀態, 前日結存, 現金, 匯款, [刷卡/支票], 支出, 備註, 當日結存) 
                VALUES (N'" & PA & "', N'" & PA1 & "', N'" & PA2 & "', N'" & PA3 & "', N'', N'', N'', N'', N'', N'', N'')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_客製表1_修改()
        ConnOpen()
        SQL1 = "UPDATE YD客製報表1 SET  A1 = N'" & PA2 & "', A2 = N'" & PA3 & "', A3 = N'" & PA4 & "', 
                                      A4 = N'" & PA5 & "', A5 = N'" & PA6 & "', A6 = N'" & PA7 & "', A7 = N'" & PA8 & "', A8 = N'" & PA9 & "'
                WHERE (流水號 LIKE N'" & PA1 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_客製表2_修改()
        ConnOpen()
        SQL1 = "UPDATE YD客製報表2 SET 前日結存 = N'" & PA4 & "', 現金 = N'" & PA5 & "', 
                                       匯款 = N'" & PA6 & "', [刷卡/支票] = N'" & PA7 & "', 支出 = N'" & PA8 & "', 備註 = N'" & PA9 & "', 當日結存 = N'" & PA10 & "'
                WHERE (流水號 LIKE N'" & PA1 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_客製表_訂單控制表()
        ConnOpen()
        SQL1 = "SELECT      銷售控制表.流水號, 銷售控制表.單號, 客戶資料表.名稱, 銷售控制表.開單日期, 銷售控制表.交貨日期, 
                            銷售控制表.含稅, 銷售控制表.單位主管, 銷售控制表.審核日期, 銷售收款事項.內容, 銷售收款事項.金額 AS 未收額額, 
                            銷售控制表.送貨地點, 銷售控制表.運費, 銷售控制表.客戶編號, 客戶資料表.電話1, 客戶資料表.電話2, 
                            客戶資料表.地址, 客戶資料表.公司名稱, 客戶資料表.統編, 銷售控制表.稅金, 銷售控制表.已出貨 AS 出貨, 
                            銷售控制表.轉業績日期, 銷售控制表.已出貨 AS 已結單, 銷售控制表.銷貨總額
                FROM        銷售控制表 INNER JOIN
                            客戶資料表 ON 銷售控制表.客戶編號 = 客戶資料表.舊編 INNER JOIN
                                (SELECT          銷售明細表.單號
                                  FROM               銷售明細表 INNER JOIN
                                                              物料資料庫 ON 銷售明細表.料號 = 物料資料庫.料號
                                  GROUP BY    銷售明細表.單號) AS QQQ ON 銷售控制表.單號 = QQQ.單號 LEFT OUTER JOIN
                            銷售收款事項 ON 銷售控制表.單號 = 銷售收款事項.單號
                WHERE      (銷售控制表.單號 LIKE '" & PA19 & "%') AND (銷售收款事項.內容 LIKE '未收餘額') AND (客戶資料表.名稱 LIKE N'%" & PA20 & "%') OR
                           (銷售控制表.單號 LIKE '" & PA19 & "%') AND (銷售收款事項.內容 LIKE '未收餘額') AND (客戶資料表.電話1 LIKE N'%" & PA20 & "%') OR
                           (銷售控制表.單號 LIKE '" & PA19 & "%') AND (銷售收款事項.內容 LIKE '未收餘額') AND (客戶資料表.電話2 LIKE N'%" & PA20 & "%') OR
                           (銷售控制表.單號 LIKE '" & PA19 & "%') AND (銷售收款事項.內容 LIKE '未收餘額') AND (客戶資料表.地址 LIKE N'%" & PA20 & "%') OR
                           (銷售控制表.單號 LIKE '" & PA19 & "%') AND (銷售收款事項.內容 LIKE '未收餘額') AND (客戶資料表.公司名稱 LIKE N'%" & PA20 & "%') OR
                           (銷售控制表.單號 LIKE '" & PA19 & "%') AND (銷售收款事項.內容 LIKE '未收餘額') AND (客戶資料表.統編 LIKE N'%" & PA20 & "%')
                ORDER BY   CHARINDEX(LEFT(銷售控制表.單號, 1), '123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'), 銷售控制表.單號 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_客製表_查詢費用清單()
        ConnOpen()
        SQL1 = "SELECT      公帳流水帳.支付單號, 公帳流水帳.項次, 會計科目.會計科目, 公帳流水帳.明細 AS 用途, 
                            Cast(公帳流水帳.零用金 AS money) AS 零用金, Cast(公帳流水帳.支票數 AS money) AS 支票, Cast(公帳流水帳.收入 AS money) AS 收入, 
                            Cast(公帳流水帳.支出 AS money) AS 支出, 公帳流水帳.備註 AS 票期, 公帳流水帳.匯率, 公帳流水帳.銀行 AS 幣別, 公帳流水帳.類別, 公帳流水帳.流水號
                FROM        公帳流水帳 INNER JOIN
                            會計科目 ON 公帳流水帳.類別 = 會計科目.編號 INNER JOIN
                            公帳控制表 ON 公帳流水帳.支付單號 = 公帳控制表.支付單號
                WHERE      (公帳控制表.申請日期 LIKE '" & PA & "') 
                ORDER BY    公帳流水帳.項次"
        CmdSet_For_DGV()
    End Sub
End Module

